package su.a71.new_soviet.registration;

import net.fabricmc.fabric.api.itemgroup.v1.FabricItemGroup;
import net.fabricmc.fabric.api.object.builder.v1.block.FabricBlockSettings;
import net.fabricmc.fabric.api.registry.FlammableBlockRegistry;
import net.minecraft.block.*;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.ItemStack;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.sound.BlockSoundGroup;
import net.minecraft.text.Text;
import net.minecraft.util.DyeColor;
import net.minecraft.util.Identifier;
import su.a71.new_soviet.blocks.CheckerBlock;
import su.a71.new_soviet.blocks.ConcreteWithBarsBlock;
import su.a71.new_soviet.blocks.HandrailBlock;
import su.a71.new_soviet.sounds.Sounds;

public class NSE_Blocks extends NSE_BaseRegistration {

    // BUILDING BRICKS/TILES ====================
    public static final Block SAND_TILES = new Block(FabricBlockSettings.create().sounds(NSE_Sounds.SAND_TILES_SOUNDS).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.TERRACOTTA_BROWN));
    public static final StairsBlock SAND_TILES_STAIRS = new StairsBlock(SAND_TILES.getDefaultState(), FabricBlockSettings.copy(SAND_TILES));
    public static final Block CRACKED_SAND_TILES = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block MOSSY_SAND_TILES = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block SMALL_SAND_TILES = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block SMALL_CRACKED_SAND_TILES = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block HERRINGBONE_SAND_TILES = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block CROSS_SAND_TILES = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block BIG_SAND_TILES = new Block(FabricBlockSettings.copy(SAND_TILES).sounds(BlockSoundGroup.DECORATED_POT));
    public static final Block SAND_BRICKS = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block CRACKED_SAND_BRICKS = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block MOSSY_SAND_BRICKS = new Block(FabricBlockSettings.copy(SAND_TILES));
    public static final Block BIG_SAND_BRICKS = new Block(FabricBlockSettings.copy(SAND_TILES));

    public static final Block BRICK_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.TERRACOTTA_BROWN));
    public static final Block CRACKED_BRICK_TILES = new Block(FabricBlockSettings.copy(BRICK_TILES));
    public static final Block MOSSY_BRICK_TILES = new Block(FabricBlockSettings.copy(BRICK_TILES));
    public static final Block DIRTY_BRICK_TILES = new Block(FabricBlockSettings.copy(BRICK_TILES));
    public static final Block DARK_BRICK_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.DARK_RED));
    public static final Block CRACKED_DARK_BRICK_TILES = new Block(FabricBlockSettings.copy(DARK_BRICK_TILES));
    public static final Block MOSSY_DARK_BRICK_TILES = new Block(FabricBlockSettings.copy(DARK_BRICK_TILES));
    public static final Block DIRTY_DARK_BRICK_TILES = new Block(FabricBlockSettings.copy(DARK_BRICK_TILES));
    public static final Block GLAZED_BRICK_TILES = new Block(FabricBlockSettings.copy(BRICK_TILES));
    public static final Block CRACKED_GLAZED_BRICK_TILES = new Block(FabricBlockSettings.copy(BRICK_TILES));
    public static final Block RED_BRICKS = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.DEEPSLATE_BRICKS).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.RED));
    public static final Block CRACKED_RED_BRICKS = new Block(FabricBlockSettings.copy(RED_BRICKS));
    public static final Block MOSSY_RED_BRICKS = new Block(FabricBlockSettings.copy(RED_BRICKS));

    public static final Block TEAL_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.TEAL));
    public static final Block CRACKED_TEAL_TILES = new Block(FabricBlockSettings.copy(TEAL_TILES));
    public static final Block MOSSY_TEAL_TILES = new Block(FabricBlockSettings.copy(TEAL_TILES));
    public static final Block SMALL_TEAL_TILES = new Block(FabricBlockSettings.copy(TEAL_TILES));
    public static final Block SMALL_CRACKED_TEAL_TILES = new Block(FabricBlockSettings.copy(TEAL_TILES));
    public static final Block GLAZED_TEAL_TILES = new Block(FabricBlockSettings.copy(TEAL_TILES));
    public static final Block CRACKED_GLAZED_TEAL_TILES = new Block(FabricBlockSettings.copy(TEAL_TILES));
    public static final Block VARIATED_TEAL_TILES = new Block(FabricBlockSettings.copy(TEAL_TILES));

    public static final Block BIG_GREEN_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.DECORATED_POT).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.TEAL));
    public static final Block BIG_GREEN_TILES_CRACKED = new Block(FabricBlockSettings.copy(BIG_GREEN_TILES));
    public static final Block GREEN_BRICKS = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.NETHER_BRICKS).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.DARK_GREEN));
    public static final Block CRACKED_GREEN_BRICKS = new Block(FabricBlockSettings.copy(GREEN_BRICKS));
    public static final Block MOSSY_GREEN_BRICKS = new Block(FabricBlockSettings.copy(GREEN_BRICKS));
    public static final Block GREEN_BRICKS_2 = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.NETHER_BRICKS).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.DARK_GREEN));
    public static final Block CRACKED_GREEN_BRICKS_2 = new Block(FabricBlockSettings.copy(GREEN_BRICKS_2));
    public static final Block MOSSY_GREEN_BRICKS_2 = new Block(FabricBlockSettings.copy(GREEN_BRICKS_2));

    public static final Block AQUAMARINE_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.DARK_AQUA));
    public static final Block CRACKED_AQUAMARINE_TILES = new Block(FabricBlockSettings.copy(AQUAMARINE_TILES));
    public static final Block MOSSY_AQUAMARINE_TILES = new Block(FabricBlockSettings.copy(AQUAMARINE_TILES));
    public static final Block DIRTY_AQUAMARINE_TILES = new Block(FabricBlockSettings.copy(AQUAMARINE_TILES));
    public static final Block SMALL_AQUAMARINE_TILES = new Block(FabricBlockSettings.copy(AQUAMARINE_TILES));
    public static final Block SMALL_CRACKED_AQUAMARINE_TILES = new Block(FabricBlockSettings.copy(AQUAMARINE_TILES));
    public static final Block GLAZED_AQUAMARINE_TILES = new Block(FabricBlockSettings.copy(AQUAMARINE_TILES));
    public static final Block CRACKED_GLAZED_AQUAMARINE_TILES = new Block(FabricBlockSettings.copy(AQUAMARINE_TILES));

    public static final Block SMALL_DIORITE_TILES = new Block(FabricBlockSettings.copy(Blocks.POLISHED_DIORITE));
    public static final Block SMALL_CRACKED_DIORITE_TILES = new Block(FabricBlockSettings.copy(Blocks.POLISHED_DIORITE));
    public static final Block BIG_DIORITE_TILES = new Block(FabricBlockSettings.copy(Blocks.POLISHED_DIORITE));
    public static final Block DIORITE_BRICKS = new Block(FabricBlockSettings.copy(Blocks.POLISHED_DIORITE));
    public static final Block CRACKED_DIORITE_BRICKS = new Block(FabricBlockSettings.copy(Blocks.POLISHED_DIORITE));
    public static final Block MOSSY_DIORITE_BRICKS = new Block(FabricBlockSettings.copy(Blocks.POLISHED_DIORITE));

    public static final Block CALCITE_TILES = new Block(FabricBlockSettings.copy(Blocks.CALCITE));
    public static final Block CRACKED_CALCITE_TILES = new Block(FabricBlockSettings.copy(Blocks.CALCITE));
    public static final Block MOSSY_CALCITE_TILES = new Block(FabricBlockSettings.copy(Blocks.CALCITE));
    public static final Block DIAGONAL_CALCITE_TILES = new Block(FabricBlockSettings.copy(Blocks.CALCITE));

    public static final Block NII_WALL_1 = new Block(FabricBlockSettings.copy(Blocks.DIORITE));
    public static final Block CRACKED_NII_WALL_1 = new Block(FabricBlockSettings.copy(NSE_Blocks.NII_WALL_1));
    public static final Block NII_WALL_2 = new Block(FabricBlockSettings.copy(NSE_Blocks.NII_WALL_1).mapColor(DyeColor.LIGHT_GRAY));
    public static final Block NII_WALL_3 = new Block(FabricBlockSettings.copy(NSE_Blocks.NII_WALL_1).mapColor(DyeColor.GRAY));

    public static final Block DRIPSTONE_TILES = new Block(FabricBlockSettings.copy(Blocks.DRIPSTONE_BLOCK));
    public static final Block CRACKED_DRIPSTONE_TILES = new Block(FabricBlockSettings.copy(Blocks.DRIPSTONE_BLOCK));
    public static final Block MOSSY_DRIPSTONE_TILES = new Block(FabricBlockSettings.copy(Blocks.DRIPSTONE_BLOCK));
    public static final Block DRIPSTONE_BRICKS = new Block(FabricBlockSettings.copy(Blocks.DRIPSTONE_BLOCK));

    public static final Block DEEPSLATE_TILES = new Block(FabricBlockSettings.copy(Blocks.DEEPSLATE_TILES));
    public static final Block CRACKED_DEEPSLATE_TILES = new Block(FabricBlockSettings.copy(Blocks.DEEPSLATE_TILES));
    public static final Block MOSSY_DEEPSLATE_TILES = new Block(FabricBlockSettings.copy(Blocks.DEEPSLATE_TILES));
    public static final Block SMALL_DEEPSLATE_TILES = new Block(FabricBlockSettings.copy(Blocks.DEEPSLATE_TILES));
    public static final Block SMALL_CRACKED_DEEPSLATE_TILES = new Block(FabricBlockSettings.copy(Blocks.DEEPSLATE_TILES));
    public static final Block DIAGONAL_DEEPSLATE_TILES = new Block(FabricBlockSettings.copy(Blocks.DEEPSLATE_TILES));

    public static final Block LIGHT_BLUE_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).strength(1.5f, 6f).requiresTool().mapColor(MapColor.LIGHT_BLUE));
    public static final Block CRACKED_LIGHT_BLUE_TILES = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));
    public static final Block MOSSY_LIGHT_BLUE_TILES = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));
    public static final Block VARIATED_LIGHT_BLUE_TILES = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES).strength(1.5f, 6f).requiresTool().mapColor(MapColor.LIGHT_BLUE));
    public static final Block SMALL_LIGHT_BLUE_TILES = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));
    public static final Block SMALL_CRACKED_LIGHT_BLUE_TILES = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));
    public static final Block GLAZED_LIGHT_BLUE_TILES = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));
    public static final Block CRACKED_GLAZED_LIGHT_BLUE_TILES = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));
    public static final Block LIGHT_BLUE_BRICKS = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));
    public static final Block CRACKED_LIGHT_BLUE_BRICKS = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));
    public static final Block MOSSY_LIGHT_BLUE_BRICKS = new Block(FabricBlockSettings.copy(LIGHT_BLUE_TILES));

    public static final Block BIG_GRANITE_TILES = new Block(FabricBlockSettings.copy(Blocks.POLISHED_GRANITE));
    public static final Block SMALL_GRANITE_TILES = new Block(FabricBlockSettings.copy(Blocks.POLISHED_GRANITE));
    public static final Block SMALL_CRACKED_GRANITE_TILES = new Block(FabricBlockSettings.copy(Blocks.POLISHED_GRANITE));

    public static final Block GREEN_WHITE_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).hardness(1.5f).requiresTool().resistance(6f).mapColor(MapColor.OFF_WHITE));
    public static final Block CRACKED_GREEN_WHITE_TILES = new Block(FabricBlockSettings.copy(GREEN_WHITE_TILES));
    public static final Block MOSSY_GREEN_WHITE_TILES = new Block(FabricBlockSettings.copy(GREEN_WHITE_TILES));

    public static final Block TUFF_TILES = new Block(FabricBlockSettings.copy(Blocks.TUFF));
    public static final Block CRACKED_TUFF_TILES = new Block(FabricBlockSettings.copy(Blocks.TUFF));
    public static final Block MOSSY_TUFF_TILES = new Block(FabricBlockSettings.copy(Blocks.TUFF));
    public static final Block BIG_TUFF_TILES = new Block(FabricBlockSettings.copy(Blocks.TUFF));
    public static final Block TUFF_BRICKS = new Block(FabricBlockSettings.copy(Blocks.TUFF));
    public static final Block CRACKED_TUFF_BRICKS = new Block(FabricBlockSettings.copy(Blocks.TUFF));
    public static final Block MOSSY_TUFF_BRICKS = new Block(FabricBlockSettings.copy(Blocks.TUFF));

    public static final Block SMALL_WHITE_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).strength(1.5f, 6f).requiresTool().mapColor(MapColor.WHITE));
    public static final Block SMALL_CRACKED_WHITE_TILES = new Block(FabricBlockSettings.copy(SMALL_WHITE_TILES));
    public static final Block GLAZED_WHITE_TILES = new Block(FabricBlockSettings.copy(SMALL_WHITE_TILES));
    public static final Block CRACKED_GLAZED_WHITE_TILES = new Block(FabricBlockSettings.copy(SMALL_WHITE_TILES));

    public static final Block SMALL_YELLOW_TILES = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).strength(1.5f, 6f).requiresTool().mapColor(MapColor.YELLOW));
    public static final Block SMALL_CRACKED_YELLOW_TILES = new Block(FabricBlockSettings.copy(SMALL_YELLOW_TILES));

    public static final Block WHITEWASH = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).strength(1.5f, 6f).requiresTool().mapColor(MapColor.OFF_WHITE));
    public static final Block CRACKED_WHITEWASH = new Block(FabricBlockSettings.copy(WHITEWASH));
    public static final Block VERY_CRACKED_WHITEWASH = new Block(FabricBlockSettings.copy(WHITEWASH));

    public static final Block WHITE_CONCRETE = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).strength(1.5f, 6f).requiresTool().mapColor(MapColor.OFF_WHITE));
    public static final Block CRACKED_WHITE_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE));
    public static final ConcreteWithBarsBlock WHITE_CONCRETE_WITH_BARS = new ConcreteWithBarsBlock(FabricBlockSettings.copy(WHITE_CONCRETE));
    public static final Block BEIGE_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.OAK_TAN));
    public static final Block CRACKED_BEIGE_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.OAK_TAN));
    public static final ConcreteWithBarsBlock BEIGE_CONCRETE_WITH_BARS = new ConcreteWithBarsBlock(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.OAK_TAN));
    public static final Block BLUE_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_BLUE));
    public static final Block CRACKED_BLUE_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_BLUE));
    public static final ConcreteWithBarsBlock BLUE_CONCRETE_WITH_BARS = new ConcreteWithBarsBlock(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_BLUE));
    public static final Block RED_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_RED));
    public static final Block CRACKED_RED_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_RED));
    public static final ConcreteWithBarsBlock RED_CONCRETE_WITH_BARS = new ConcreteWithBarsBlock(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_RED));
    public static final Block YELLOW_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_YELLOW));
    public static final Block CRACKED_YELLOW_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_YELLOW));
    public static final ConcreteWithBarsBlock YELLOW_CONCRETE_WITH_BARS = new ConcreteWithBarsBlock(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_YELLOW));
    public static final Block GREEN_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_GREEN));
    public static final Block CRACKED_GREEN_CONCRETE = new Block(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_GREEN));
    public static final ConcreteWithBarsBlock GREEN_CONCRETE_WITH_BARS = new ConcreteWithBarsBlock(FabricBlockSettings.copy(WHITE_CONCRETE).mapColor(MapColor.TERRACOTTA_GREEN));

    // WOOD/FLOOR ==========
    public static final Block HERRINGBONE_ACACIA_PLANKS = new Block(FabricBlockSettings.copy(Blocks.ACACIA_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block CROSS_ACACIA_PLANKS = new Block(FabricBlockSettings.copy(Blocks.ACACIA_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block HERRINGBONE_OAK_PLANKS = new Block(FabricBlockSettings.copy(Blocks.OAK_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block CROSS_OAK_PLANKS = new Block(FabricBlockSettings.copy(Blocks.OAK_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block HERRINGBONE_BIRCH_PLANKS = new Block(FabricBlockSettings.copy(Blocks.BIRCH_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block CROSS_BIRCH_PLANKS = new Block(FabricBlockSettings.copy(Blocks.BIRCH_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block HERRINGBONE_CRIMSON_PLANKS = new Block(FabricBlockSettings.copy(Blocks.CRIMSON_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block CROSS_CRIMSON_PLANKS = new Block(FabricBlockSettings.copy(Blocks.CRIMSON_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block HERRINGBONE_DARK_OAK_PLANKS = new Block(FabricBlockSettings.copy(Blocks.DARK_OAK_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block CROSS_DARK_OAK_PLANKS = new Block(FabricBlockSettings.copy(Blocks.DARK_OAK_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block HERRINGBONE_JUNGLE_PLANKS = new Block(FabricBlockSettings.copy(Blocks.JUNGLE_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block CROSS_JUNGLE_PLANKS = new Block(FabricBlockSettings.copy(Blocks.JUNGLE_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block HERRINGBONE_MANGROVE_PLANKS = new Block(FabricBlockSettings.copy(Blocks.MANGROVE_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block CROSS_MANGROVE_PLANKS = new Block(FabricBlockSettings.copy(Blocks.MANGROVE_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block HERRINGBONE_SPRUCE_PLANKS = new Block(FabricBlockSettings.copy(Blocks.SPRUCE_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));
    public static final Block CROSS_SPRUCE_PLANKS = new Block(FabricBlockSettings.copy(Blocks.SPRUCE_PLANKS).sounds(NSE_Sounds.PARQUET_SOUNDS));

    public static final Block HERRINGBONE_PARQUET = new Block(FabricBlockSettings.create().sounds(NSE_Sounds.PARQUET_SOUNDS).strength(2f, 3f).mapColor(MapColor.OAK_TAN));
    public static final Block STRAIGHT_PARQUET = new Block(FabricBlockSettings.copy(HERRINGBONE_PARQUET));
    public static final Block SEPARATED_PARQUET = new Block(FabricBlockSettings.copy(HERRINGBONE_PARQUET));

    public static final Block GREEN_LINOLEUM = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.CHERRY_WOOD).strength(2, 3f).mapColor(MapColor.TERRACOTTA_GREEN));
    public static final Block BLUE_LINOLEUM = new Block(FabricBlockSettings.copy(GREEN_LINOLEUM).mapColor(MapColor.TERRACOTTA_BLUE));
    public static final Block RED_LINOLEUM = new Block(FabricBlockSettings.copy(GREEN_LINOLEUM).mapColor(MapColor.TERRACOTTA_RED));
    public static final Block GRAY_LINOLEUM = new Block(FabricBlockSettings.copy(GREEN_LINOLEUM).mapColor(MapColor.TERRACOTTA_GRAY));
    public static final Block ORANGE_LINOLEUM = new Block(FabricBlockSettings.copy(GREEN_LINOLEUM).mapColor(MapColor.TERRACOTTA_ORANGE));
    public static final Block BROWN_LINOLEUM = new Block(FabricBlockSettings.copy(GREEN_LINOLEUM).mapColor(MapColor.TERRACOTTA_BROWN));
    public static final Block CYAN_LINOLEUM = new Block(FabricBlockSettings.copy(GREEN_LINOLEUM).mapColor(MapColor.CYAN));
    public static final Block CROSS_ORANGE_LINOLEUM = new Block(FabricBlockSettings.copy(GREEN_LINOLEUM).mapColor(MapColor.ORANGE));
    public static final Block CROSS_BROWN_LINOLEUM = new Block(FabricBlockSettings.copy(GREEN_LINOLEUM).mapColor(MapColor.BROWN));

    public static final DoorBlock CHISELED_MANGROVE_DOOR = new DoorBlock(FabricBlockSettings.copy(Blocks.MANGROVE_DOOR), BlockSetType.MANGROVE);
    public static final DoorBlock CHISELED_OAK_DOOR = new DoorBlock(FabricBlockSettings.copy(Blocks.OAK_DOOR), BlockSetType.OAK);
    public static final DoorBlock CHISELED_SPRUCE_DOOR = new DoorBlock(FabricBlockSettings.copy(Blocks.SPRUCE_DOOR), BlockSetType.SPRUCE);
    public static final DoorBlock CHISELED_BIRCH_DOOR = new DoorBlock(FabricBlockSettings.copy(Blocks.BIRCH_DOOR), BlockSetType.BIRCH);

    public static final Block NII_FLOOR = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.POLISHED_DEEPSLATE).strength(1.5f, 6f).requiresTool().mapColor(MapColor.GRAY));

    // Industrial ==========
    public static final Block INDUSTRIAL_WARNING = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.METAL).hardness(4f).resistance(6f).requiresTool().mapColor(MapColor.BLACK));
    public static final Block RED_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.RED));
    public static final Block ORANGE_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.ORANGE));
    public static final Block YELLOW_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.YELLOW));
    public static final Block CYAN_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.CYAN));
    public static final Block LIGHT_BLUE_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.LIGHT_BLUE));
    public static final Block BLUE_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.BLUE));
    public static final Block LIME_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.LIME));
    public static final Block GREEN_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.GREEN));
    public static final Block GRAY_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.GRAY));
    public static final Block PURPLE_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.PURPLE));
    public static final Block MAGENTA_WARNING = new Block(FabricBlockSettings.copy(INDUSTRIAL_WARNING).mapColor(MapColor.MAGENTA));

    public static final Block METAL_PLATING = new Block(FabricBlockSettings.create().sounds(BlockSoundGroup.NETHERITE).hardness(5f).requiresTool().mapColor(MapColor.IRON_GRAY));
    public static final BarrelBlock CRATE = new BarrelBlock(FabricBlockSettings.create().sounds(BlockSoundGroup.CHISELED_BOOKSHELF).nonOpaque().mapColor(MapColor.OAK_TAN).hardness(1.8f));
    public static final WallBlock CONCRETE_WALL = new WallBlock(FabricBlockSettings.create().sounds(BlockSoundGroup.STONE).mapColor(MapColor.STONE_GRAY));

    // WALLPAPER BLOCKS ==========
    public static final Block GREEN_WALLPAPER = new Block(FabricBlockSettings.create().sounds(NSE_Sounds.WALLPAPER_BLOCK_SOUNDS).nonOpaque().mapColor(MapColor.DARK_GREEN).hardness(10f));
    public static final Block BROWN_WALLPAPER = new Block(FabricBlockSettings.copy(GREEN_WALLPAPER).mapColor(MapColor.BROWN));
    public static final Block BEIGE_WALLPAPER = new Block(FabricBlockSettings.copy(GREEN_WALLPAPER).mapColor(MapColor.DIRT_BROWN));

    // MEAT (cursed...) ==========
    public static final Block MEAT = new Block(FabricBlockSettings.create().velocityMultiplier(0.8f).sounds(NSE_Sounds.MEAT_SOUNDS).nonOpaque().mapColor(MapColor.DARK_RED).hardness(8f));
    public static final Block MEAT_EYE = new Block(FabricBlockSettings.copy(MEAT));
    public static final Block MEAT_TEETH = new Block(FabricBlockSettings.copy(MEAT));
    public static final SnowBlock PURPLE_GOO = new SnowBlock(FabricBlockSettings.copy(MEAT).hardness(1.2f).nonOpaque());

    public static final HandrailBlock HANDRAIL = new HandrailBlock(FabricBlockSettings.create().sounds(BlockSoundGroup.COPPER).hardness(4f).nonOpaque());

    private static final ItemGroup NSE_BUILDING_TAB = FabricItemGroup.builder()
            .icon(() -> new ItemStack(CALCITE_TILES))
            .displayName(Text.translatable("itemGroup.new_soviet.building_blocks"))
            .build();

    public static void init() {
        Registry.register(Registries.ITEM_GROUP, new Identifier("new_soviet", "building_blocks"), NSE_BUILDING_TAB);
        registerBlock("sand_tiles", () -> SAND_TILES, NSE_BUILDING_TAB);
        registerBlock("sand_tiles_stairs", () -> SAND_TILES_STAIRS, NSE_BUILDING_TAB);
        registerBlock("cracked_sand_tiles", () -> CRACKED_SAND_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_sand_tiles", () -> MOSSY_SAND_TILES, NSE_BUILDING_TAB);
        registerBlock("small_sand_tiles", () -> SMALL_SAND_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_sand_tiles", () -> SMALL_CRACKED_SAND_TILES, NSE_BUILDING_TAB);
        registerBlock("herringbone_sand_tiles", () -> HERRINGBONE_SAND_TILES, NSE_BUILDING_TAB);
        registerBlock("cross_sand_tiles", () -> CROSS_SAND_TILES, NSE_BUILDING_TAB);
        registerBlock("big_sand_tiles", () -> BIG_SAND_TILES, NSE_BUILDING_TAB);
        registerBlock("sand_bricks", () -> SAND_BRICKS, NSE_BUILDING_TAB);
        registerBlock("cracked_sand_bricks", () -> CRACKED_SAND_BRICKS, NSE_BUILDING_TAB);
        registerBlock("mossy_sand_bricks", () -> MOSSY_SAND_BRICKS, NSE_BUILDING_TAB);
        registerBlock("big_sand_bricks", () -> BIG_SAND_BRICKS, NSE_BUILDING_TAB);
        //brick
        registerBlock("brick_tiles", () -> BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_brick_tiles", () -> CRACKED_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_brick_tiles", () -> MOSSY_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("dirty_brick_tiles", () -> DIRTY_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("dark_brick_tiles", () -> DARK_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_dark_brick_tiles", () -> CRACKED_DARK_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_dark_brick_tiles", () -> MOSSY_DARK_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("dirty_dark_brick_tiles", () -> DIRTY_DARK_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("glazed_brick_tiles", () -> GLAZED_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_glazed_brick_tiles", () -> CRACKED_GLAZED_BRICK_TILES, NSE_BUILDING_TAB);
        registerBlock("red_bricks", () -> RED_BRICKS, NSE_BUILDING_TAB);
        registerBlock("cracked_red_bricks", () -> CRACKED_RED_BRICKS, NSE_BUILDING_TAB);
        registerBlock("mossy_red_bricks", () -> MOSSY_RED_BRICKS, NSE_BUILDING_TAB);
        registerBlock("teal_tiles", () -> TEAL_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_teal_tiles", () -> CRACKED_TEAL_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_teal_tiles", () -> MOSSY_TEAL_TILES, NSE_BUILDING_TAB);
        registerBlock("small_teal_tiles", () -> SMALL_TEAL_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_teal_tiles", () -> SMALL_CRACKED_TEAL_TILES, NSE_BUILDING_TAB);
        registerBlock("glazed_teal_tiles", () -> GLAZED_TEAL_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_glazed_teal_tiles", () -> CRACKED_GLAZED_TEAL_TILES, NSE_BUILDING_TAB);
        registerBlock("variated_teal_tiles", () -> VARIATED_TEAL_TILES, NSE_BUILDING_TAB);

        registerBlock("big_green_tiles", () -> BIG_GREEN_TILES, NSE_BUILDING_TAB);
        registerBlock("big_green_tiles_cracked", () -> BIG_GREEN_TILES_CRACKED, NSE_BUILDING_TAB);
        registerBlock("green_bricks", () -> GREEN_BRICKS, NSE_BUILDING_TAB);
        registerBlock("cracked_green_bricks", () -> CRACKED_GREEN_BRICKS, NSE_BUILDING_TAB);
        registerBlock("mossy_green_bricks", () -> MOSSY_GREEN_BRICKS, NSE_BUILDING_TAB);
        registerBlock("green_bricks_2", () -> GREEN_BRICKS_2, NSE_BUILDING_TAB);
        registerBlock("cracked_green_bricks_2", () -> CRACKED_GREEN_BRICKS_2, NSE_BUILDING_TAB);
        registerBlock("mossy_green_bricks_2", () -> MOSSY_GREEN_BRICKS_2, NSE_BUILDING_TAB);

        registerBlock("aquamarine_tiles", () -> AQUAMARINE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_aquamarine_tiles", () -> CRACKED_AQUAMARINE_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_aquamarine_tiles", () -> MOSSY_AQUAMARINE_TILES, NSE_BUILDING_TAB);
        registerBlock("dirty_aquamarine_tiles", () -> DIRTY_AQUAMARINE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_aquamarine_tiles", () -> SMALL_AQUAMARINE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_aquamarine_tiles", () -> SMALL_CRACKED_AQUAMARINE_TILES, NSE_BUILDING_TAB);
        registerBlock("glazed_aquamarine_tiles", () -> GLAZED_AQUAMARINE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_glazed_aquamarine_tiles", () -> CRACKED_GLAZED_AQUAMARINE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_diorite_tiles", () -> SMALL_DIORITE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_diorite_tiles", () -> SMALL_CRACKED_DIORITE_TILES, NSE_BUILDING_TAB);
        registerBlock("big_diorite_tiles", () -> BIG_DIORITE_TILES, NSE_BUILDING_TAB);
        registerBlock("diorite_bricks", () -> DIORITE_BRICKS, NSE_BUILDING_TAB);
        registerBlock("cracked_diorite_bricks", () -> CRACKED_DIORITE_BRICKS, NSE_BUILDING_TAB);
        registerBlock("mossy_diorite_bricks", () -> MOSSY_DIORITE_BRICKS, NSE_BUILDING_TAB);
        registerBlock("calcite_tiles", () -> CALCITE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_calcite_tiles", () -> CRACKED_CALCITE_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_calcite_tiles", () -> MOSSY_CALCITE_TILES, NSE_BUILDING_TAB);
        registerBlock("diagonal_calcite_tiles", () -> DIAGONAL_CALCITE_TILES, NSE_BUILDING_TAB);
        //nii walls
        registerBlock("nii_wall_1", () -> NII_WALL_1, NSE_BUILDING_TAB);
        registerBlock("cracked_nii_wall_1", () -> CRACKED_NII_WALL_1, NSE_BUILDING_TAB);
        registerBlock("nii_wall_2", () -> NII_WALL_2, NSE_BUILDING_TAB);
        registerBlock("nii_wall_3", () -> NII_WALL_3, NSE_BUILDING_TAB);
        //dripstone
        registerBlock("dripstone_tiles", () -> DRIPSTONE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_dripstone_tiles", () -> CRACKED_DRIPSTONE_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_dripstone_tiles", () -> MOSSY_DRIPSTONE_TILES, NSE_BUILDING_TAB);
        registerBlock("dripstone_bricks", () -> DRIPSTONE_BRICKS, NSE_BUILDING_TAB);
        registerBlock("deepslate_tiles", () -> DEEPSLATE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_deepslate_tiles", () -> CRACKED_DEEPSLATE_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_deepslate_tiles", () -> MOSSY_DEEPSLATE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_deepslate_tiles", () -> SMALL_DEEPSLATE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_deepslate_tiles", () -> SMALL_CRACKED_DEEPSLATE_TILES, NSE_BUILDING_TAB);
        registerBlock("diagonal_deepslate_tiles", () -> DIAGONAL_DEEPSLATE_TILES, NSE_BUILDING_TAB);
        registerBlock("light_blue_tiles", () -> LIGHT_BLUE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_light_blue_tiles", () -> CRACKED_LIGHT_BLUE_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_light_blue_tiles", () -> MOSSY_LIGHT_BLUE_TILES, NSE_BUILDING_TAB);
        registerBlock("variated_light_blue_tiles", () -> VARIATED_LIGHT_BLUE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_light_blue_tiles", () -> SMALL_LIGHT_BLUE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_light_blue_tiles", () -> SMALL_CRACKED_LIGHT_BLUE_TILES, NSE_BUILDING_TAB);
        registerBlock("glazed_light_blue_tiles", () -> GLAZED_LIGHT_BLUE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_glazed_light_blue_tiles", () -> CRACKED_GLAZED_LIGHT_BLUE_TILES, NSE_BUILDING_TAB);
        registerBlock("light_blue_bricks", () -> LIGHT_BLUE_BRICKS, NSE_BUILDING_TAB);
        registerBlock("cracked_light_blue_bricks", () -> CRACKED_LIGHT_BLUE_BRICKS, NSE_BUILDING_TAB);
        registerBlock("mossy_light_blue_bricks", () -> MOSSY_LIGHT_BLUE_BRICKS, NSE_BUILDING_TAB);
        registerBlock("big_granite_tiles", () -> BIG_GRANITE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_granite_tiles", () -> SMALL_GRANITE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_granite_tiles", () -> SMALL_CRACKED_GRANITE_TILES, NSE_BUILDING_TAB);
        registerBlock("green_white_tiles", () -> GREEN_WHITE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_green_white_tiles", () -> CRACKED_GREEN_WHITE_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_green_white_tiles", () -> MOSSY_GREEN_WHITE_TILES, NSE_BUILDING_TAB);
        registerBlock("tuff_tiles", () -> TUFF_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_tuff_tiles", () -> CRACKED_TUFF_TILES, NSE_BUILDING_TAB);
        registerBlock("mossy_tuff_tiles", () -> MOSSY_TUFF_TILES, NSE_BUILDING_TAB);
        registerBlock("big_tuff_tiles", () -> BIG_TUFF_TILES, NSE_BUILDING_TAB);
        registerBlock("tuff_bricks", () -> TUFF_BRICKS, NSE_BUILDING_TAB);
        registerBlock("cracked_tuff_bricks", () -> CRACKED_TUFF_BRICKS, NSE_BUILDING_TAB);
        registerBlock("mossy_tuff_bricks", () -> MOSSY_TUFF_BRICKS, NSE_BUILDING_TAB);
        registerBlock("small_white_tiles", () -> SMALL_WHITE_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_white_tiles", () -> SMALL_CRACKED_WHITE_TILES, NSE_BUILDING_TAB);
        registerBlock("glazed_white_tiles", () -> GLAZED_WHITE_TILES, NSE_BUILDING_TAB);
        registerBlock("cracked_glazed_white_tiles", () -> CRACKED_GLAZED_WHITE_TILES, NSE_BUILDING_TAB);

        registerBlock("small_yellow_tiles", () -> SMALL_YELLOW_TILES, NSE_BUILDING_TAB);
        registerBlock("small_cracked_yellow_tiles", () -> SMALL_CRACKED_YELLOW_TILES, NSE_BUILDING_TAB);

        registerBlock("whitewash", () -> WHITEWASH, NSE_BUILDING_TAB);
        registerBlock("cracked_whitewash", () -> CRACKED_WHITEWASH, NSE_BUILDING_TAB);
        registerBlock("very_cracked_whitewash", () -> VERY_CRACKED_WHITEWASH, NSE_BUILDING_TAB);

        registerBlock("white_concrete", () -> WHITE_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("cracked_white_concrete", () -> CRACKED_WHITE_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("white_concrete_with_bars", () -> WHITE_CONCRETE_WITH_BARS, NSE_BUILDING_TAB);
        registerBlock("beige_concrete", () -> BEIGE_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("cracked_beige_concrete", () -> CRACKED_BEIGE_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("beige_concrete_with_bars", () -> BEIGE_CONCRETE_WITH_BARS, NSE_BUILDING_TAB);
        registerBlock("blue_concrete", () -> BLUE_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("cracked_blue_concrete", () -> CRACKED_BLUE_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("blue_concrete_with_bars", () -> BLUE_CONCRETE_WITH_BARS, NSE_BUILDING_TAB);
        registerBlock("red_concrete", () -> RED_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("cracked_red_concrete", () -> CRACKED_RED_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("red_concrete_with_bars", () -> RED_CONCRETE_WITH_BARS, NSE_BUILDING_TAB);
        registerBlock("yellow_concrete", () -> YELLOW_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("cracked_yellow_concrete", () -> CRACKED_YELLOW_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("yellow_concrete_with_bars", () -> YELLOW_CONCRETE_WITH_BARS, NSE_BUILDING_TAB);
        registerBlock("green_concrete", () -> GREEN_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("cracked_green_concrete", () -> CRACKED_GREEN_CONCRETE, NSE_BUILDING_TAB);
        registerBlock("green_concrete_with_bars", () -> GREEN_CONCRETE_WITH_BARS, NSE_BUILDING_TAB);

        registerBlock("nii_floor", () -> NII_FLOOR, NSE_BUILDING_TAB);

        registerBlock("herringbone_acacia_planks", () -> HERRINGBONE_ACACIA_PLANKS, NSE_BUILDING_TAB);
        registerBlock("cross_acacia_planks", () -> CROSS_ACACIA_PLANKS, NSE_BUILDING_TAB);
        registerBlock("herringbone_oak_planks", () -> HERRINGBONE_OAK_PLANKS, NSE_BUILDING_TAB);
        registerBlock("cross_oak_planks", () -> CROSS_OAK_PLANKS, NSE_BUILDING_TAB);
        registerBlock("herringbone_birch_planks", () -> HERRINGBONE_BIRCH_PLANKS, NSE_BUILDING_TAB);
        registerBlock("cross_birch_planks", () -> CROSS_BIRCH_PLANKS, NSE_BUILDING_TAB);
        registerBlock("herringbone_crimson_planks", () -> HERRINGBONE_CRIMSON_PLANKS, NSE_BUILDING_TAB);
        registerBlock("cross_crimson_planks", () -> CROSS_CRIMSON_PLANKS, NSE_BUILDING_TAB);
        registerBlock("herringbone_dark_oak_planks", () -> HERRINGBONE_DARK_OAK_PLANKS, NSE_BUILDING_TAB);
        registerBlock("cross_dark_oak_planks", () -> CROSS_DARK_OAK_PLANKS, NSE_BUILDING_TAB);
        registerBlock("herringbone_jungle_planks", () -> HERRINGBONE_JUNGLE_PLANKS, NSE_BUILDING_TAB);
        registerBlock("cross_jungle_planks", () -> CROSS_JUNGLE_PLANKS, NSE_BUILDING_TAB);
        registerBlock("herringbone_mangrove_planks", () -> HERRINGBONE_MANGROVE_PLANKS, NSE_BUILDING_TAB);
        registerBlock("cross_mangrove_planks", () -> CROSS_MANGROVE_PLANKS, NSE_BUILDING_TAB);
        registerBlock("herringbone_spruce_planks", () -> HERRINGBONE_SPRUCE_PLANKS, NSE_BUILDING_TAB);
        registerBlock("cross_spruce_planks", () -> CROSS_SPRUCE_PLANKS, NSE_BUILDING_TAB);

        registerBlock("herringbone_parquet", () -> HERRINGBONE_PARQUET, NSE_BUILDING_TAB);
        registerBlock("straight_parquet", () -> STRAIGHT_PARQUET, NSE_BUILDING_TAB);
        registerBlock("separated_parquet", () -> SEPARATED_PARQUET, NSE_BUILDING_TAB);

        registerBlock("green_linoleum", () -> GREEN_LINOLEUM, NSE_BUILDING_TAB);
        registerBlock("blue_linoleum", () -> BLUE_LINOLEUM, NSE_BUILDING_TAB);
        registerBlock("red_linoleum", () -> RED_LINOLEUM, NSE_BUILDING_TAB);
        registerBlock("gray_linoleum", () -> GRAY_LINOLEUM, NSE_BUILDING_TAB);
        registerBlock("orange_linoleum", () -> ORANGE_LINOLEUM, NSE_BUILDING_TAB);
        registerBlock("brown_linoleum", () -> BROWN_LINOLEUM, NSE_BUILDING_TAB);
        registerBlock("cyan_linoleum", () -> CYAN_LINOLEUM, NSE_BUILDING_TAB);
        registerBlock("cross_orange_linoleum", () -> CROSS_ORANGE_LINOLEUM, NSE_BUILDING_TAB);
        registerBlock("cross_brown_linoleum", () -> CROSS_BROWN_LINOLEUM, NSE_BUILDING_TAB);

        registerBlock("chiseled_mangrove_door", () -> CHISELED_MANGROVE_DOOR, NSE_BUILDING_TAB);
        registerBlock("chiseled_oak_door", () -> CHISELED_OAK_DOOR, NSE_BUILDING_TAB);
        registerBlock("chiseled_spruce_door", () -> CHISELED_SPRUCE_DOOR, NSE_BUILDING_TAB);
        registerBlock("chiseled_birch_door", () -> CHISELED_BIRCH_DOOR, NSE_BUILDING_TAB);

        registerBlock("industrial_warning", () -> INDUSTRIAL_WARNING, NSE_BUILDING_TAB);
        registerBlock("gray_warning", () -> GRAY_WARNING, NSE_BUILDING_TAB);
        registerBlock("red_warning", () -> RED_WARNING, NSE_BUILDING_TAB);
        registerBlock("orange_warning", () -> ORANGE_WARNING, NSE_BUILDING_TAB);
        registerBlock("yellow_warning", () -> YELLOW_WARNING, NSE_BUILDING_TAB);
        registerBlock("lime_warning", () -> LIME_WARNING, NSE_BUILDING_TAB);
        registerBlock("green_warning", () -> GREEN_WARNING, NSE_BUILDING_TAB);
        registerBlock("cyan_warning", () -> CYAN_WARNING, NSE_BUILDING_TAB);
        registerBlock("light_blue_warning", () -> LIGHT_BLUE_WARNING, NSE_BUILDING_TAB);
        registerBlock("blue_warning", () -> BLUE_WARNING, NSE_BUILDING_TAB);
        registerBlock("purple_warning", () -> PURPLE_WARNING, NSE_BUILDING_TAB);
        registerBlock("magenta_warning", () -> MAGENTA_WARNING, NSE_BUILDING_TAB);

        registerBlock("metal_plating", () -> METAL_PLATING, NSE_BUILDING_TAB);
        registerBlock("crate", () -> CRATE, NSE_BUILDING_TAB);
        registerBlock("concrete_wall", () -> CONCRETE_WALL, NSE_BUILDING_TAB);  // TODO: Broken

        registerBlock("green_wallpaper", () -> GREEN_WALLPAPER, NSE_BUILDING_TAB);
        registerBlock("brown_wallpaper", () -> BROWN_WALLPAPER, NSE_BUILDING_TAB);
        registerBlock("beige_wallpaper", () -> BEIGE_WALLPAPER, NSE_BUILDING_TAB);

        registerBlock("meat", () -> MEAT, NSE_BUILDING_TAB);
        registerBlock("meat_eye", () -> MEAT_EYE, NSE_BUILDING_TAB);
        registerBlock("meat_teeth", () -> MEAT_TEETH, NSE_BUILDING_TAB);
        registerBlock("purple_goo", () -> PURPLE_GOO, NSE_BUILDING_TAB);
        registerBlock("handrail", () -> HANDRAIL, NSE_BUILDING_TAB);

        // Flammable blocks!
        FlammableBlockRegistry flammableBlockRegistry = FlammableBlockRegistry.getDefaultInstance();
        flammableBlockRegistry.add(HERRINGBONE_ACACIA_PLANKS, 20, 5);
        flammableBlockRegistry.add(CROSS_ACACIA_PLANKS, 20, 5);
        flammableBlockRegistry.add(HERRINGBONE_OAK_PLANKS, 20, 5);
        flammableBlockRegistry.add(CROSS_OAK_PLANKS, 20, 5);
        flammableBlockRegistry.add(HERRINGBONE_OAK_PLANKS, 20, 5);
        flammableBlockRegistry.add(HERRINGBONE_BIRCH_PLANKS, 20, 5);
        flammableBlockRegistry.add(CROSS_BIRCH_PLANKS, 20, 5);
        // Crimson doesn't burn!
        flammableBlockRegistry.add(HERRINGBONE_DARK_OAK_PLANKS, 20, 5);
        flammableBlockRegistry.add(CROSS_DARK_OAK_PLANKS, 20, 5);
        flammableBlockRegistry.add(HERRINGBONE_JUNGLE_PLANKS, 20, 5);
        flammableBlockRegistry.add(CROSS_JUNGLE_PLANKS, 20, 5);
        flammableBlockRegistry.add(HERRINGBONE_MANGROVE_PLANKS, 20, 5);
        flammableBlockRegistry.add(CROSS_MANGROVE_PLANKS, 20, 5);
        flammableBlockRegistry.add(HERRINGBONE_SPRUCE_PLANKS, 20, 5);
        flammableBlockRegistry.add(CROSS_SPRUCE_PLANKS, 20, 5);

        flammableBlockRegistry.add(HERRINGBONE_PARQUET, 20, 5);
        flammableBlockRegistry.add(STRAIGHT_PARQUET, 20, 5);
        flammableBlockRegistry.add(SEPARATED_PARQUET, 20, 5);

        flammableBlockRegistry.add(GREEN_LINOLEUM, 20, 5);
        flammableBlockRegistry.add(BLUE_LINOLEUM, 20, 5);
        flammableBlockRegistry.add(RED_LINOLEUM, 20, 5);
        flammableBlockRegistry.add(GRAY_LINOLEUM, 20, 5);
        flammableBlockRegistry.add(ORANGE_LINOLEUM, 20, 5);
        flammableBlockRegistry.add(BROWN_LINOLEUM, 20, 5);
        flammableBlockRegistry.add(CYAN_LINOLEUM, 20, 5);
        flammableBlockRegistry.add(CROSS_ORANGE_LINOLEUM, 20, 5);
        flammableBlockRegistry.add(CROSS_BROWN_LINOLEUM, 20, 5);
    }
}
